<?php
/*
*	Syndeo CMS
* 	is a website management system designed for primary schools.
* =============================================================================== *
* Syndeo CMS Software Version: 2.8.00  
* Copyright (C) 2008: Fred Stuurman (fc.stuurman@gmail.com)
* Album module: 
* functions.inc.php: last changed 26/02/2009 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
*/

// setPointer - Sets the pointer to the provided $value in provided $array
function setPointer(&$array, $value) 
{	
	// Set array pointer to first element
	reset($array);
	
	// Cycle through array
	while ($value != current($array)) 
	{
		// Advance the pointer
		next($array);
	}
}

function resize_picture($image, $new_size)
{
	@set_time_limit(30);
	
	if (function_exists('imagecreatetruecolor'))
	{
		ini_set('memory_limit', '50M');
		
		$size = getimagesize($image);
		$x = $size[0];
		$y = $size[1];
		if ($x < $y)
		{
			$newy = $new_size;
			$newx = $x / ($y / $newy);
			$format = "portrait";
		}
		else
		{
			$newx = $new_size;
			$newy = $y / ($x / $newx);
			$format = "landscape";
		}
		$tmp = explode(".", $image);
		$ext = array_pop($tmp);

		if($x > $new_size)	//size is to big we need to resize
		{
		
			if (($ext == "jpg") or ($ext == "JPG"))
			{
				$src_img = imagecreatefromjpeg($image);
				$dst_img = ImageCreateTrueColor($newx, $newy);
				imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $newx, $newy, $x, $y);
				imagejpeg($dst_img, $image, "100");
				imagedestroy($src_img);
				imagedestroy($dst_img);
			}
			elseif (($ext == "png") or ($ext == "PNG"))
			{
				$src_img = imagecreatefrompng($image);
				$dst_img = ImageCreateTrueColor($newx, $newy);
				imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $newx, $newy, $x, $y);
				imagepng($dst_img, $image, "9"); //changed for php 5.x from 100 -> 9
				imagedestroy($src_img);
				imagedestroy($dst_img);
			}
		}
	}
}


function del_picture_files($target, $ext)
{
	//function which deletes files and directories from the media/pictures/$target directory
	//is called when picture page is deleted from the system
	//$ext can be "_t" or "_m" or blank, if blank all files are deleted

	global $sas_config;

	$exceptions = array (
		".",
		".."
	); //skip those

	$picture_path = $sas_config['serverpath'] . $sas_config['user_path'] . "/media/gallery/";
	if (file_exists($picture_path. $target))
	{
		$dh = opendir($picture_path . $target);
	
		while (false !== ($file_name = readdir($dh)))
		{
			if (!in_array($file_name, $exceptions))
			{
				if (is_file($picture_path . $target . "/" . $file_name))
				{
					if(($ext == "_t") OR ($ext == "_m"))		//a delete for _t.jpg or _m.jpg files is requested.
					{
						$file_name = make_thumb_name($file_name, $ext) ;
					}
					// unlink file
					if (file_exists($picture_path . $target . "/" . $file_name)) 
					{
						unlink($picture_path . $target . "/" . $file_name);
					}
				}
			}
		}
	}
	closedir($dh);
	return true;
} // end of the 'delete_files()' function

function set_path($target, $cat_id)
{
	//when an album gets an other name the subalbums need to get a new path.
	
	global $db, $table_pictures_cat ;
	
	$query = "SELECT id, pagename FROM $table_pictures_cat WHERE parent = '".$cat_id."'";
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);
	$RecordCount = mysqli_num_rows($result);
		
	if ($RecordCount > 0)
	{
		while ($cat_list = mysqli_fetch_array($result))
		{
			$path = remove_special_characters($cat_list[1]);
			$path =  $target . "/" . $path ;
			mysqli_query($db,"UPDATE $table_pictures_cat SET path = '" . $path . "' WHERE id = '" . $cat_list[0] . "'") ;
			$cat_list_next = remove_special_characters($cat_list[1]);
			set_path($target."/".$cat_list_next, $cat_list[0]) ;
		}
	}
}

function show_album_path ($id)
{
	global $db, $page, $section, $table_pictures_cat, $output, $i ;
	
	$query = "SELECT pagename, parent FROM $table_pictures_cat where id = '$id' LIMIT 1";
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);
	$RecordCount = mysqli_num_rows($result);
		
	if ($RecordCount > 0)
	{
		$i++;
		$pagename = mysqli_result($result, 0, 'pagename');
		$parent = mysqli_result($result, 0, 'parent');

		if($i == 1) 
		{
			$output = ">> <span class=\"sas_module_title\">" . $pagename . " </span>";
		}
		else
		{
			$output = ">> <a href=\"index.php?section=$section&page=$page&modoption=list&cat_id=$id\" class=\"sas_module_link\">" . $pagename . "</a> " . $output;
		}
		
		show_album_path ($parent) ;
	}
	else
	{
		print substr($output,2);
	}
}

?>